# Reactter examples

This page contains several examples with different feature of reactter.

## Quickstart

Run next commands:

```shell
flutter create .
flutter run
```

for [Github search example](#github-search) add http permission:

- [Android](https://docs.flutter.dev/development/data-and-backend/networking#android)
- [IOS](https://guides.codepath.com/ios/Internet-Permissions)

## Counter

Increment and decrement counter.

Learn how to change value state.

[![Counter example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/counter_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/counter)

Implements: `ReactterBuilder`, `ReactterContext`, `ReactterProvider`, `UseContext`, `UseState`.

## Todos

Add, remove todo to list, mark, unmark todo as completed and filter todo list.

Learn how to add context dynamic and manage its state.

[![Todos example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/todos_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/todos)

Implements: `ReactterBuilder`, `ReactterComponent`, `ReactterContext`, `ReactterProvider`, `UseContext`, `UseState`, `UseEffect`.

## Shopping cart

Add, remove product to cart and checkout.

Learn how to access to other context and keep its state.

[![Shopping cart example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/cart_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/shopping_cart)

Implements: `ReactterBuilder`, `ReactterComponent`, `ReactterContext`, `ReactterProvider`, `UseContext`, `UseState`, `UseEffect`.

## Tree widget

Add, remove and hide child widget with counter.

Learn how to add or remove context dynamic and keep its state.

[![Tree widget example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/tree_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/tree)

Implements: `ReactterBuilder`, `ReactterComponent`, `ReactterContext`, `ReactterProvider`, `UseContext`, `UseState`.

## Github search

Search user or repository and show info about it.

Learn how to manage state in async way.

[![Github search example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/api_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/api)

Implements: `ReactterBuilder`, `ReactterContext`, `ReactterComponent`, `ReactterProvider`, `UseContext`, `UseAsyncState`, `UseState`.

## Animate widget

Change size, shape and color.

Learn how to create a custom hook.

[![Animate widget example](https://raw.githubusercontent.com/2devs-team/reactter_assets/main/examples/animation_example.gif)](https://github.com/2devs-team/reactter/tree/master/example/lib/examples/animation)

Implements: `ReactterBuilder`, `ReactterContext`, `ReactterHook`, `ReactterProvider`, `ReactterSubscribersManager`, `UseContext`.
